include qlib.inc

;MISC stuff for C programs
.data
  align 4
  rmcs callstruct <>  ;RM call struct
  sregs1 SREGS <>  ;used in int86 (to call int86x)

.code
outp proc,p:word,d:byte
  push dx
  mov al,d
  mov dx,p
  out dx,al
  pop dx
  xor eax,eax
  ret
outp endp

inp proc,p:word
  push dx
  mov dx,p
  in al,dx
  pop dx
  ret
inp endp

outpw proc,p:word,d:word
  push dx
  mov ax,d
  mov dx,p
  out dx,ax
  pop dx
  xor eax,eax
  ret
outpw endp

inpw proc,p:word
  push dx
  mov dx,p
  in ax,dx
  pop dx
  ret
inpw endp

int86 proc,i:byte,rin:dword,rout:dword
  .if i==3
    int 3   ;0cch
    ret
  .endif
  mov eax,offset SREGS1
  mov [eax].SREGS._ds,0
  mov [eax].SREGS._es,0
  mov [eax].SREGS._fs,0
  mov [eax].SREGS._gs,0
  callp int86x,i,rin,rout,offset SREGS1
  ret
int86 endp

int86x proc,i:byte,rin:dword,rout:dword,sreg:dword
  pushad
  mov esi,rin
  mov edi,offset rmcs

  mov eax,[esi].REGS.d._eax
  mov [edi].callstruct._eax,eax

  mov eax,[esi].REGS.d._ebx
  mov [edi].callstruct._ebx,eax

  mov eax,[esi].REGS.d._ecx
  mov [edi].callstruct._ecx,eax

  mov eax,[esi].REGS.d._edx
  mov [edi].callstruct._edx,eax

  mov eax,[esi].REGS.d._esi
  mov [edi].callstruct._esi,eax

  mov eax,[esi].REGS.d._edi
  mov [edi].callstruct._edi,eax

  mov eax,[esi].REGS.d.cflag
  and ax,1
  mov [edi].callstruct._flg,ax

  mov ax,[esi].SREGS._ds
  mov [edi].callstruct._ds,ax

  mov ax,[esi].SREGS._es
  mov [edi].callstruct._es,ax

  mov ax,[esi].SREGS._fs
  mov [edi].callstruct._fs,ax

  mov ax,[esi].SREGS._gs
  mov [edi].callstruct._gs,ax

;  mov [edi].callstruct._cs,0    ;all already 0
;  mov [edi].callstruct._ip,0
;  mov [edi].callstruct._ss,0
;  mov [edi].callstruct._sp,0

  mov ax,300h
  mov bl,i
  xor bh,bh
  mov cx,0
  ;es:edi=callstruct
  int 31h

  mov esi,rout
  mov edi,offset rmcs

  mov eax,[edi].callstruct._eax
  mov [esi].REGS.d._eax,eax

  mov eax,[edi].callstruct._ebx
  mov [esi].REGS.d._ebx,eax

  mov eax,[edi].callstruct._ecx
  mov [esi].REGS.d._ecx,eax

  mov eax,[edi].callstruct._edx
  mov [esi].REGS.d._edx,eax

  movzx eax,[edi].callstruct._flg
  and eax,1
  mov [esi].REGS.d.cflag,eax

  mov eax,[edi].callstruct._esi
  mov [esi].REGS.d._esi,eax

  mov eax,[edi].callstruct._edi
  mov [esi].REGS.d._edi,eax

  mov ax,[edi].callstruct._ds
  mov [esi].SREGS._ds,ax

  mov ax,[edi].callstruct._es
  mov [esi].SREGS._es,ax

  mov ax,[edi].callstruct._fs
  mov [esi].SREGS._fs,ax

  mov ax,[edi].callstruct._gs
  mov [esi].SREGS._gs,ax
  popad
  ret
int86x endp

int386 proc,i:byte,rin:dword,rout:dword
  pushad
  mov al,i
  mov intnum1,al
  mov eax,rin

  mov ebx,[eax].REGS.d._ebx
  mov ecx,[eax].REGS.d._ecx
  mov edx,[eax].REGS.d._edx
  mov esi,[eax].REGS.d._esi
  mov edi,[eax].REGS.d._edi
  .if [eax].REGS.d.cflag
    stc
  .else
    clc
  .endif
  mov eax,[eax].REGS.d._eax
  jmp far1
far1:
  db 0cdh
  intnum1 db 3
  pushf
  push eax
  mov eax,rout
  pop [eax].REGS.d._eax
  mov [eax].REGS.d._ebx,ebx
  mov [eax].REGS.d._ecx,ecx
  mov [eax].REGS.d._edx,edx
  mov [eax].REGS.d._esi,esi
  mov [eax].REGS.d._edi,edi
  pop ax
  .if ax&1
    mov [eax].REGS.d.cflag,1
  .else
    mov [eax].REGS.d.cflag,0
  .endif
  popad
  xor eax,eax
  ret
int386 endp

; int386x - I see no reason for that... do you?

end

